// Control.cpp: implementation of the CControl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectDraw.h"
#include "Control.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define RES_X			640
#define RES_Y			480
#define RES_BITDEPTH	16
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define _S_BACKSLASH_CHAR								_T('\\')

CControl::CControl()
{
	m_bReady = FALSE;
}

CControl::~CControl()
{
	delete m_surBackground;
}

HRESULT CControl::DDInit(HWND hWnd)
{
    HRESULT dwResult;

	//
	// Get program path 
	CString csBMPPath = AfxGetAppName();
	GetModuleFileName(NULL, csBMPPath.GetBuffer(MAX_PATH), MAX_PATH);
	csBMPPath.ReleaseBuffer();	
	int i = csBMPPath.ReverseFind(_S_BACKSLASH_CHAR);
	csBMPPath = csBMPPath.Left(i + 1);	
	//
	// Create DD system
	dwResult = m_theDisplay.CreateFullScreenDisplay(hWnd, RES_X, RES_Y, RES_BITDEPTH);
	if(dwResult != DD_OK) {
		TRACE("Cannot init direct draw system due %d\n", dwResult);
        return dwResult;
	}
	m_csBackground = csBMPPath + "background.bmp";
	m_surBackground = new CSurface;
	dwResult = m_theDisplay.CreateSurfaceFromBitmap(&m_surBackground, (TCHAR*)(LPCSTR)m_csBackground, 0, 0);
	if(dwResult != DD_OK) {
		TRACE("Cannot create background due %d\n", dwResult);
        return dwResult;
	}		
	//
	// Init sprites
	m_sprShow.CreateStaticSprite(CString(csBMPPath + "sprite.bmp").GetBuffer(0), CPoint(150, 60));
	m_sprShow.SetVelX(2);
	m_sprAnimShow.CreateAnimatedSprite(CString(csBMPPath + "plane1.bmp").GetBuffer(0), CPoint(100, 300), 12, 50);

	// Run update loop
	m_bReady = TRUE;

    return dwResult;
}

void CControl::UpdateFrame()
{
	DWORD dwRet;
	if(m_bReady) {
		//...
		CRect rcBackground;
		rcBackground.SetRect(0,0,RES_X, RES_Y);

		dwRet = m_theDisplay.Blt(0, 0, m_surBackground, rcBackground);	
		if(dwRet != DD_OK) {			
			if(dwRet == DDERR_SURFACELOST) { 
				m_surBackground->GetDDrawSurface()->Restore();
				m_surBackground->DrawBitmap((TCHAR*)(LPCSTR)m_csBackground, 0, 0);
			}
		}
		//...
		//
		// Bound moving sprite in the screen
		CPoint ptPos = m_sprShow.GetPosition();
		int iVelX = m_sprShow.GetVelX();
		if(ptPos.x >= RES_X-150 || ptPos.x <= 0) {
			m_sprShow.SetVelX(-iVelX);
		}		
		//
		// Update first sprite
		m_sprShow.MoveSprite();
		m_sprShow.DrawSprite();
		//...
		// Update second sprite
		m_sprAnimShow.ChangeAnimationPhase();
		m_sprAnimShow.DrawSprite();
		//...
		m_theDisplay.Present();		
	}
}
