// Sprite.h: interface for the CSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPRITE_H__9712C94A_5189_4A3F_A1A5_8F867C788079__INCLUDED_)
#define AFX_SPRITE_H__9712C94A_5189_4A3F_A1A5_8F867C788079__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define		SPRITESTATE_STANDARD		0
#define		DEFAULT_MAXVEL				1

class CSprite  
{
	CPoint		m_ptPos;
	int			m_iVelX;
	int			m_iVelY;
	int			m_iMaxVel;
	int			m_iCurrentPhase;
	int			m_iPhasesCount;
	int			m_iAnimationSpeed;
	DWORD		m_dwLastUpdate;
	DWORD		m_dwState;
	int			m_iWidth;
	int			m_iHeight;

	CDisplay	*m_pDisplay;
	CSurface	*m_psurSpriteSurface;
	CString		m_csBitmap;

public:
	HRESULT		CreateStaticSprite(LPSTR szSpriteBitmap, CPoint ptInitPos);
	HRESULT		CreateAnimatedSprite(LPSTR szSpriteBitmap, CPoint ptInitPos, int iPhasesCount, int	iAnimationSpeed);
	HRESULT		DrawSprite();
	HRESULT		MoveSprite();
	HRESULT		ChangeAnimationPhase();
	//
	// Inline functions
	DWORD		GetState() {return m_dwState;}
	void		SetState(DWORD dwState) {m_dwState = dwState;}
	void		SetVelX(int VelX) {m_iVelX = VelX;}
	void		SetVelY(int VelY) {m_iVelY = VelY;}
	void		SetPosition(CPoint ptPos) {m_ptPos = ptPos;}
	void		SetPosition(int x, int y) {m_ptPos = CPoint(x, y);}
	CPoint		GetPosition() {return m_ptPos;}
	int			GetVelX() {return m_iVelX;}

public:
	CSprite();
	~CSprite();
};

#endif // !defined(AFX_SPRITE_H__9712C94A_5189_4A3F_A1A5_8F867C788079__INCLUDED_)
